package gssim.gssimstudio.flex.app.editor;

import java.io.*;
import java.util.*;

import org.vinetoolkit.ResourceManager;
import org.vinetoolkit.ServiceContext;
import org.vinetoolkit.Session;

import org.vinetoolkit.web.spi.annotation.BlazeDsDestination;
import org.vinetoolkit.web.spi.annotation.BlazeDsMethod;
import org.vinetoolkit.web.flex.blazeds.shared.utils.VineFlexUtilClass;
import org.vinetoolkit.web.portlet.spi.annotation.PortletDisplayName;
import org.vinetoolkit.role.VineRoleManager;
import org.vinetoolkit.spi.util.ServiceLog;

import flex.messaging.FlexContext;
import org.vinetoolkit.web.spi.annotation.BlazeDsDestination;
import org.vinetoolkit.web.spi.annotation.BlazeDsMethod;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItem;
import org.vinetoolkit.io.*;
import org.vinetoolkit.io.sets.FileLocationSet;
import org.vinetoolkit.ServiceContext;
import org.vinetoolkit.Location;
import org.vinetoolkit.task.TaskMonitor;
import org.vinetoolkit.task.TaskOptions;
import org.vinetoolkit.task.TaskException;
import org.vinetoolkit.localhost.io.FileSystemResource;
import org.vinetoolkit.localhost.io.FileSystemManager;
import org.vinetoolkit.spi.util.ServiceLog;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Timestamp;

import org.vinetoolkit.web.flex.blazeds.shared.uibackend.ModelInitialization;
import org.vinetoolkit.web.flex.blazeds.shared.uibackend.FileUploadAccepter;
import java.security.Principal;

import gssim.db.dao.data.Allocation;
import gssim.db.dao.data.AllocationDetails;
import gssim.db.dao.data.BlobProperty;
import gssim.db.dao.data.Configuration;
import gssim.db.dao.data.Metaexperiment;
import gssim.db.dao.data.Experiment;
import gssim.db.dao.data.ExperimentStats;
import gssim.db.dao.data.Queues;
import gssim.db.dao.data.Plugin;
import gssim.db.dao.data.PluginCompatibility;
import gssim.db.dao.data.Reservation;
import gssim.db.dao.data.ReservationDetails;
import gssim.db.dao.data.Resource;
import gssim.db.dao.data.ResourceAllTimeline;
import gssim.db.dao.data.ResourceEnTimeline;
import gssim.db.dao.data.Task;
import gssim.db.dao.data.TextProperty;
import gssim.db.dao.data.Unit;
import gssim.db.dao.data.UnitAllTimeline;
import gssim.db.dao.data.UnitDetails;
import gssim.db.dao.data.UnitEnTimeline;
import gssim.db.dao.data.User;
import gssim.db.find.Finder;
import gssim.db.mysql.AllocationDAO;
import gssim.db.mysql.AllocationDetailsDAO;
import gssim.db.mysql.BlobPropertyDAO;
import gssim.db.mysql.ConfigurationDAO;
import gssim.db.mysql.ExperimentDAO;
import gssim.db.mysql.MetaexperimentDAO;
import gssim.db.mysql.ExperimentStatsDAO;
import gssim.db.mysql.MySQLDAOFactory;
import gssim.db.mysql.QueuesDAO;
import gssim.db.mysql.PluginDAO;
import gssim.db.mysql.PluginCompatibilityDAO;
import gssim.db.mysql.ReservationDAO;
import gssim.db.mysql.ReservationDetailsDAO;
import gssim.db.mysql.ResourceAllTimelineDAO;
import gssim.db.mysql.ResourceDAO;
import gssim.db.mysql.ResourceEnTimelineDAO;
import gssim.db.mysql.TaskDAO;
import gssim.db.mysql.TextPropertyDAO;
import gssim.db.mysql.UnitAllTimelineDAO;
import gssim.db.mysql.UnitDAO;
import gssim.db.mysql.UnitDetailsDAO;
import gssim.db.mysql.UnitEnTimelineDAO;
import gssim.db.mysql.UserDAO;

import java.net.MalformedURLException;

import javax.servlet.ServletContext;

/**
 * @author Mateusz Cichenski, Jarek Szymczak
 */
@BlazeDsDestination(portletEntry = false, locales = {"en_US","pl_PL"}, names = {"GSSim Studio","GSSim Studio"}, descriptions = {"Application for GSSim job description","Aplikacja do generowania zada� dla symulatora GSSim"})
public class GanntChart extends DatabaseHelper {

	private Boolean developement = true;

	private static MySQLDAOFactory factory;

	/**
	 * Logger instance for this class
	 */
    private ServiceLog log = ServiceLog.getInstance(GanntChart.class);
    
    @BlazeDsMethod()
    public GanntChartModel getImageURLs(Integer expId, FileResourceManager fileResourceManager) throws IOException {
    	GanntChartModel model = (GanntChartModel) VineFlexUtilClass.getUIModel();
    	log.debug("loadFileLocationItems images");

    	//FIXME: get this info from different source maybe?
        String url = "gsiftp://gssim.man.poznan.pl:2811/usr/local/admin/liferay-portal-5.2.3/tomcat-5.5.27/webapps/images/"+ expId + "/?filetype=directory";
        
        // Create file location for url
        FileLocation folderLocation = new FileLocation(url);

        // Get file manager for given location
        FileManager fileManager = fileResourceManager.createFileManager(folderLocation);

        // List workload files
        ArrayList<HashMap> fileLocationItemList = new ArrayList<HashMap>();
        model.setImageFileList(fileLocationItemList);
        loadFileLocationItemsForCurrentLocation(model, fileManager, fileLocationItemList);
        
        return model;
    }
    
    public void loadFileLocationItemsForCurrentLocation(GanntChartModel fileListComModel, FileManager fileManager, ArrayList<HashMap> fileLocationItemList) throws IOException {

        log.debug("loadFileLocationItemsForCurrentLocation images");

        try {
        	// Update current folder location
            FileLocation folderLocation = fileManager.getCurrentLocation();

            // Current location item
            HashMap<String, String> currentLocationItem = new HashMap<String, String>();
            //fileListComModel.setCurrentLocationItem(currentLocationItem);

            currentLocationItem.put("real_path", folderLocation.getFilePath());
            currentLocationItem.put("path", fileManager.getCurrentDirectory());
            currentLocationItem.put("url", folderLocation.getUrl());
            currentLocationItem.put("downloadUrl", VineFlexUtilClass.getDownloadURL(folderLocation));

            // List files in defafult directory
            List<? extends FileLocation> fileLocationList;
            try {

                fileLocationList = fileManager.list();

            } catch (Exception e) {
                log.error("Error occured during list", e);
                return;
            }

            ServletContext servletContext = FlexContext.getServletContext();
            
            for (FileLocation fileLocation : fileLocationList) {            	
                HashMap<String, String> fileLocationItem = new HashMap<String, String>();
                fileLocationItemList.add(fileLocationItem);

                // File url (not displayed?)
                String fileUrl = fileLocation.getUrl();
                fileLocationItem.put("fileUrl", fileUrl);

                String fileUrlWithoutQuery = fileLocation.getUrlWithoutQuery();
                fileLocationItem.put("fileUrlWithoutQuery", fileUrlWithoutQuery);

                // File name
                String fileName = fileLocation.getFileName();
                fileLocationItem.put("fileName", fileName);

                // File type
                FileType fileType = fileLocation.getFileType();
                fileLocationItem.put("fileType", fileType.getName());

                // Date modified column

                long dateLastModified = fileLocation.getDateLastModified();

                fileLocationItem.put("dateModified", String.valueOf(dateLastModified));

                // Date modified column
                //fileLocationItem.put("dateModifiedText", DateUtil.getLocalizedDate(dateLastModified, DateFormat.MEDIUM, DateFormat.MEDIUM));

                // File size column
                long fileSize = fileLocation.getFileSize();
                fileLocationItem.put("fileSize", String.valueOf(fileSize));

                // File size column
                fileLocationItem.put("fileSizeText", String.valueOf(fileSize) + " bytes");

                fileLocationItem.put("folderUrl", folderLocation.getUrl());
                
                String contentType = servletContext.getMimeType(fileLocation.getFileName().toLowerCase());
            	String openUrl = null;
                if (contentType != null) {
                    openUrl = VineFlexUtilClass.getURL(fileLocation, contentType);
                } else {
                    openUrl = VineFlexUtilClass.getDownloadURL(fileLocation);
                }
                fileLocationItem.put("fileAccessUrl", openUrl);
            }

            log.debug("done");

        } catch (Exception e) {
            log.error("Exception occurred during loadFileLocationGrid", e);
        }
    }
    
    @BlazeDsMethod()
	public GanntChartModel getTasksAllocationsFromDb(Integer expId) {

    	GanntChartModel model = (GanntChartModel) VineFlexUtilClass.getUIModel();
		
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			
			TaskDAO taskDAO = factory.createTask();
			
			Finder taskFinder = Finder.getTaskFinder(expId, null, null, null, null, null, null, null);
			
			List<Task> taskList = taskDAO.find(taskFinder);
			
			AllocationDAO allocationDAO = factory.createAllocation();
			
			List<Allocation> list = new ArrayList<Allocation>();
			
			for (int i = 0; i < taskList.size(); i++)
			{
				Finder allocationFinder = Finder.getAllocationFinder(taskList.get(i).getPK(), null);
				List<Allocation> allocationList = allocationDAO.find(allocationFinder);
				list.addAll(allocationList);
			}

			model.setAllocationList(list);

		} catch (SQLException e) {
			setSqlError("Gannt", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
	
	private void closeConnection(Connection connection, GanntChartModel model) {
		String error = model.getError();
		
		if (connection != null)
			try {
				connection.close();
			} catch (SQLException e) {
				error = model.getError();
				if (error == null || error.equals("")) {
					error = "Error while trying to close the SQL connection";
				} else {
					error += System.getProperty("line.separator");
					error += "Error while trying to close the SQL connection";
				}
			}

		model.setError(error);
	}

	private void setSqlError(String name, GanntChartModel model, Exception e) {
		setError(name + ": an SQL exception occured while trying retrieve data from database", model, e);
	}
	
	private void setDbConnectionError(GanntChartModel model, Exception e) {
		setError("An exception occured while trying to create MySQLDAOFactory", model, e);
	}
	
	private void setError(String messageForUser, GanntChartModel model, Exception e) {
		
		String error = messageForUser;
		
		if(developement)
		{
			error += System.getProperty("line.separator");
			error += "Error details:";
			error += System.getProperty("line.separator");
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			PrintStream ps = new PrintStream(baos);
			e.printStackTrace(ps);
			String stackTrace = baos.toString();		
			error += stackTrace;
		}
		
		model.setError(error);
	}			
	
	private MySQLDAOFactory factory() throws InstantiationException, IllegalAccessException, ClassNotFoundException {
		if(factory == null)
			factory = new MySQLDAOFactory();
		return factory;
	}
	/* END OF DB Methods */
}